Linux Audio

Check our new training course

Loading...
v4.17
  1#!/bin/bash
  2# SPDX-License-Identifier: GPL-2.0
  3# (c) 2014, Sasha Levin <sasha.levin@oracle.com>
  4#set -x
  5
  6if [[ $# < 2 ]]; then
  7	echo "Usage:"
  8	echo "	$0 [vmlinux] [base path] [modules path]"
  9	exit 1
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 10fi
 11
 12vmlinux=$1
 13basepath=$2
 14modpath=$3
 15declare -A cache
 16declare -A modcache
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 17
 18parse_symbol() {
 19	# The structure of symbol at this point is:
 20	#   ([name]+[offset]/[total length])
 21	#
 22	# For example:
 23	#   do_basic_setup+0x9c/0xbf
 24
 25	if [[ $module == "" ]] ; then
 26		local objfile=$vmlinux
 27	elif [[ "${modcache[$module]+isset}" == "isset" ]]; then
 28		local objfile=${modcache[$module]}
 29	else
 30		[[ $modpath == "" ]] && return
 31		local objfile=$(find "$modpath" -name $module.ko -print -quit)
 32		[[ $objfile == "" ]] && return
 33		modcache[$module]=$objfile
 
 
 
 
 34	fi
 35
 36	# Remove the englobing parenthesis
 37	symbol=${symbol#\(}
 38	symbol=${symbol%\)}
 39
 
 
 
 
 
 
 
 40	# Strip the symbol name so that we could look it up
 41	local name=${symbol%+*}
 42
 43	# Use 'nm vmlinux' to figure out the base address of said symbol.
 44	# It's actually faster to call it every time than to load it
 45	# all into bash.
 46	if [[ "${cache[$module,$name]+isset}" == "isset" ]]; then
 47		local base_addr=${cache[$module,$name]}
 48	else
 49		local base_addr=$(nm "$objfile" | grep -i ' t ' | awk "/ $name\$/ {print \$1}" | head -n1)
 50		cache[$module,$name]="$base_addr"
 
 
 
 
 
 
 51	fi
 52	# Let's start doing the math to get the exact address into the
 53	# symbol. First, strip out the symbol total length.
 54	local expr=${symbol%/*}
 55
 56	# Now, replace the symbol name with the base address we found
 57	# before.
 58	expr=${expr/$name/0x$base_addr}
 59
 60	# Evaluate it to find the actual address
 61	expr=$((expr))
 62	local address=$(printf "%x\n" "$expr")
 63
 64	# Pass it to addr2line to get filename and line number
 65	# Could get more than one result
 66	if [[ "${cache[$module,$address]+isset}" == "isset" ]]; then
 67		local code=${cache[$module,$address]}
 68	else
 69		local code=$(addr2line -i -e "$objfile" "$address")
 70		cache[$module,$address]=$code
 
 
 71	fi
 72
 73	# addr2line doesn't return a proper error code if it fails, so
 74	# we detect it using the value it prints so that we could preserve
 75	# the offset/size into the function and bail out
 76	if [[ $code == "??:0" ]]; then
 77		return
 78	fi
 79
 80	# Strip out the base of the path
 81	code=${code//$basepath/""}
 82
 83	# In the case of inlines, move everything to same line
 84	code=${code//$'\n'/' '}
 85
 
 
 
 
 
 
 86	# Replace old address with pretty line numbers
 87	symbol="$name ($code)"
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 88}
 89
 90decode_code() {
 91	local scripts=`dirname "${BASH_SOURCE[0]}"`
 92
 93	echo "$1" | $scripts/decodecode
 94}
 95
 96handle_line() {
 
 
 
 
 
 
 
 
 97	local words
 98
 99	# Tokenize
100	read -a words <<<"$1"
101
102	# Remove hex numbers. Do it ourselves until it happens in the
103	# kernel
104
105	# We need to know the index of the last element before we
106	# remove elements because arrays are sparse
107	local last=$(( ${#words[@]} - 1 ))
108
109	for i in "${!words[@]}"; do
110		# Remove the address
111		if [[ ${words[$i]} =~ \[\<([^]]+)\>\] ]]; then
112			unset words[$i]
113		fi
114
115		# Format timestamps with tabs
116		if [[ ${words[$i]} == \[ && ${words[$i+1]} == *\] ]]; then
117			unset words[$i]
118			words[$i+1]=$(printf "[%13s\n" "${words[$i+1]}")
119		fi
120	done
121
 
 
 
 
 
 
122	if [[ ${words[$last]} =~ \[([^]]+)\] ]]; then
123		module=${words[$last]}
124		module=${module#\[}
125		module=${module%\]}
 
 
 
 
 
126		symbol=${words[$last-1]}
127		unset words[$last-1]
128	else
129		# The symbol is the last element, process it
130		symbol=${words[$last]}
131		module=
 
132	fi
133
134	unset words[$last]
135	parse_symbol # modifies $symbol
136
137	# Add up the line number to the symbol
138	echo "${words[@]}" "$symbol $module"
139}
140
141while read line; do
 
 
 
142	# Let's see if we have an address in the line
143	if [[ $line =~ \[\<([^]]+)\>\] ]] ||
144	   [[ $line =~ [^+\ ]+\+0x[0-9a-f]+/0x[0-9a-f]+ ]]; then
145		# Translate address to line numbers
146		handle_line "$line"
147	# Is it a code line?
148	elif [[ $line == *Code:* ]]; then
149		decode_code "$line"
 
 
 
150	else
151		# Nothing special in this line, show it as is
152		echo "$line"
153	fi
154done
v6.8
  1#!/bin/bash
  2# SPDX-License-Identifier: GPL-2.0
  3# (c) 2014, Sasha Levin <sasha.levin@oracle.com>
  4#set -x
  5
  6usage() {
  7	echo "Usage:"
  8	echo "	$0 -r <release> | <vmlinux> [<base path>|auto] [<modules path>]"
  9}
 10
 11# Try to find a Rust demangler
 12if type llvm-cxxfilt >/dev/null 2>&1 ; then
 13	cppfilt=llvm-cxxfilt
 14elif type c++filt >/dev/null 2>&1 ; then
 15	cppfilt=c++filt
 16	cppfilt_opts=-i
 17fi
 18
 19UTIL_SUFFIX=
 20if [[ -z ${LLVM:-} ]]; then
 21	UTIL_PREFIX=${CROSS_COMPILE:-}
 22else
 23	UTIL_PREFIX=llvm-
 24	if [[ ${LLVM} == */ ]]; then
 25		UTIL_PREFIX=${LLVM}${UTIL_PREFIX}
 26	elif [[ ${LLVM} == -* ]]; then
 27		UTIL_SUFFIX=${LLVM}
 28	fi
 29fi
 30
 31READELF=${UTIL_PREFIX}readelf${UTIL_SUFFIX}
 32ADDR2LINE=${UTIL_PREFIX}addr2line${UTIL_SUFFIX}
 33
 34if [[ $1 == "-r" ]] ; then
 35	vmlinux=""
 36	basepath="auto"
 37	modpath=""
 38	release=$2
 39
 40	for fn in {,/usr/lib/debug}/boot/vmlinux-$release{,.debug} /lib/modules/$release{,/build}/vmlinux ; do
 41		if [ -e "$fn" ] ; then
 42			vmlinux=$fn
 43			break
 44		fi
 45	done
 46
 47	if [[ $vmlinux == "" ]] ; then
 48		echo "ERROR! vmlinux image for release $release is not found" >&2
 49		usage
 50		exit 2
 51	fi
 52else
 53	vmlinux=$1
 54	basepath=${2-auto}
 55	modpath=$3
 56	release=""
 57	debuginfod=
 58
 59	# Can we use debuginfod-find?
 60	if type debuginfod-find >/dev/null 2>&1 ; then
 61		debuginfod=${1-only}
 62	fi
 63
 64	if [[ $vmlinux == "" && -z $debuginfod ]] ; then
 65		echo "ERROR! vmlinux image must be specified" >&2
 66		usage
 67		exit 1
 68	fi
 69fi
 70
 71declare aarray_support=true
 72declare -A cache 2>/dev/null
 73if [[ $? != 0 ]]; then
 74	aarray_support=false
 75else
 76	declare -A modcache
 77fi
 78
 79find_module() {
 80	if [[ -n $debuginfod ]] ; then
 81		if [[ -n $modbuildid ]] ; then
 82			debuginfod-find debuginfo $modbuildid && return
 83		fi
 84
 85		# Only using debuginfod so don't try to find vmlinux module path
 86		if [[ $debuginfod == "only" ]] ; then
 87			return
 88		fi
 89	fi
 90
 91	if [[ "$modpath" != "" ]] ; then
 92		for fn in $(find "$modpath" -name "${module//_/[-_]}.ko*") ; do
 93			if ${READELF} -WS "$fn" | grep -qwF .debug_line ; then
 94				echo $fn
 95				return
 96			fi
 97		done
 98		return 1
 99	fi
100
101	modpath=$(dirname "$vmlinux")
102	find_module && return
103
104	if [[ $release == "" ]] ; then
105		release=$(gdb -ex 'print init_uts_ns.name.release' -ex 'quit' -quiet -batch "$vmlinux" 2>/dev/null | sed -n 's/\$1 = "\(.*\)".*/\1/p')
106	fi
107
108	for dn in {/usr/lib/debug,}/lib/modules/$release ; do
109		if [ -e "$dn" ] ; then
110			modpath="$dn"
111			find_module && return
112		fi
113	done
114
115	modpath=""
116	return 1
117}
118
119parse_symbol() {
120	# The structure of symbol at this point is:
121	#   ([name]+[offset]/[total length])
122	#
123	# For example:
124	#   do_basic_setup+0x9c/0xbf
125
126	if [[ $module == "" ]] ; then
127		local objfile=$vmlinux
128	elif [[ $aarray_support == true && "${modcache[$module]+isset}" == "isset" ]]; then
129		local objfile=${modcache[$module]}
130	else
131		local objfile=$(find_module)
132		if [[ $objfile == "" ]] ; then
133			echo "WARNING! Modules path isn't set, but is needed to parse this symbol" >&2
134			return
135		fi
136		if [[ $aarray_support == true ]]; then
137			modcache[$module]=$objfile
138		fi
139	fi
140
141	# Remove the englobing parenthesis
142	symbol=${symbol#\(}
143	symbol=${symbol%\)}
144
145	# Strip segment
146	local segment
147	if [[ $symbol == *:* ]] ; then
148		segment=${symbol%%:*}:
149		symbol=${symbol#*:}
150	fi
151
152	# Strip the symbol name so that we could look it up
153	local name=${symbol%+*}
154
155	# Use 'nm vmlinux' to figure out the base address of said symbol.
156	# It's actually faster to call it every time than to load it
157	# all into bash.
158	if [[ $aarray_support == true && "${cache[$module,$name]+isset}" == "isset" ]]; then
159		local base_addr=${cache[$module,$name]}
160	else
161		local base_addr=$(nm "$objfile" 2>/dev/null | awk '$3 == "'$name'" && ($2 == "t" || $2 == "T") {print $1; exit}')
162		if [[ $base_addr == "" ]] ; then
163			# address not found
164			return
165		fi
166		if [[ $aarray_support == true ]]; then
167			cache[$module,$name]="$base_addr"
168		fi
169	fi
170	# Let's start doing the math to get the exact address into the
171	# symbol. First, strip out the symbol total length.
172	local expr=${symbol%/*}
173
174	# Now, replace the symbol name with the base address we found
175	# before.
176	expr=${expr/$name/0x$base_addr}
177
178	# Evaluate it to find the actual address
179	expr=$((expr))
180	local address=$(printf "%x\n" "$expr")
181
182	# Pass it to addr2line to get filename and line number
183	# Could get more than one result
184	if [[ $aarray_support == true && "${cache[$module,$address]+isset}" == "isset" ]]; then
185		local code=${cache[$module,$address]}
186	else
187		local code=$(${ADDR2LINE} -i -e "$objfile" "$address" 2>/dev/null)
188		if [[ $aarray_support == true ]]; then
189			cache[$module,$address]=$code
190		fi
191	fi
192
193	# addr2line doesn't return a proper error code if it fails, so
194	# we detect it using the value it prints so that we could preserve
195	# the offset/size into the function and bail out
196	if [[ $code == "??:0" ]]; then
197		return
198	fi
199
200	# Strip out the base of the path on each line
201	code=$(while read -r line; do echo "${line#$basepath/}"; done <<< "$code")
202
203	# In the case of inlines, move everything to same line
204	code=${code//$'\n'/' '}
205
206	# Demangle if the name looks like a Rust symbol and if
207	# we got a Rust demangler
208	if [[ $name =~ ^_R && $cppfilt != "" ]] ; then
209		name=$("$cppfilt" "$cppfilt_opts" "$name")
210	fi
211
212	# Replace old address with pretty line numbers
213	symbol="$segment$name ($code)"
214}
215
216debuginfod_get_vmlinux() {
217	local vmlinux_buildid=${1##* }
218
219	if [[ $vmlinux != "" ]]; then
220		return
221	fi
222
223	if [[ $vmlinux_buildid =~ ^[0-9a-f]+ ]]; then
224		vmlinux=$(debuginfod-find debuginfo $vmlinux_buildid)
225		if [[ $? -ne 0 ]] ; then
226			echo "ERROR! vmlinux image not found via debuginfod-find" >&2
227			usage
228			exit 2
229		fi
230		return
231	fi
232	echo "ERROR! Build ID for vmlinux not found. Try passing -r or specifying vmlinux" >&2
233	usage
234	exit 2
235}
236
237decode_code() {
238	local scripts=`dirname "${BASH_SOURCE[0]}"`
239
240	echo "$1" | $scripts/decodecode
241}
242
243handle_line() {
244	if [[ $basepath == "auto" && $vmlinux != "" ]] ; then
245		module=""
246		symbol="kernel_init+0x0/0x0"
247		parse_symbol
248		basepath=${symbol#kernel_init (}
249		basepath=${basepath%/init/main.c:*)}
250	fi
251
252	local words
253
254	# Tokenize
255	read -a words <<<"$1"
256
257	# Remove hex numbers. Do it ourselves until it happens in the
258	# kernel
259
260	# We need to know the index of the last element before we
261	# remove elements because arrays are sparse
262	local last=$(( ${#words[@]} - 1 ))
263
264	for i in "${!words[@]}"; do
265		# Remove the address
266		if [[ ${words[$i]} =~ \[\<([^]]+)\>\] ]]; then
267			unset words[$i]
268		fi
269
270		# Format timestamps with tabs
271		if [[ ${words[$i]} == \[ && ${words[$i+1]} == *\] ]]; then
272			unset words[$i]
273			words[$i+1]=$(printf "[%13s\n" "${words[$i+1]}")
274		fi
275	done
276
277	if [[ ${words[$last]} =~ ^[0-9a-f]+\] ]]; then
278		words[$last-1]="${words[$last-1]} ${words[$last]}"
279		unset words[$last]
280		last=$(( $last - 1 ))
281	fi
282
283	if [[ ${words[$last]} =~ \[([^]]+)\] ]]; then
284		module=${words[$last]}
285		module=${module#\[}
286		module=${module%\]}
287		modbuildid=${module#* }
288		module=${module% *}
289		if [[ $modbuildid == $module ]]; then
290			modbuildid=
291		fi
292		symbol=${words[$last-1]}
293		unset words[$last-1]
294	else
295		# The symbol is the last element, process it
296		symbol=${words[$last]}
297		module=
298		modbuildid=
299	fi
300
301	unset words[$last]
302	parse_symbol # modifies $symbol
303
304	# Add up the line number to the symbol
305	echo "${words[@]}" "$symbol $module"
306}
307
308while read line; do
309	# Strip unexpected carriage return at end of line
310	line=${line%$'\r'}
311
312	# Let's see if we have an address in the line
313	if [[ $line =~ \[\<([^]]+)\>\] ]] ||
314	   [[ $line =~ [^+\ ]+\+0x[0-9a-f]+/0x[0-9a-f]+ ]]; then
315		# Translate address to line numbers
316		handle_line "$line"
317	# Is it a code line?
318	elif [[ $line == *Code:* ]]; then
319		decode_code "$line"
320	# Is it a version line?
321	elif [[ -n $debuginfod && $line =~ PID:\ [0-9]+\ Comm: ]]; then
322		debuginfod_get_vmlinux "$line"
323	else
324		# Nothing special in this line, show it as is
325		echo "$line"
326	fi
327done